<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/12/2005 *
 * ================                             Last change: 02/12/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_doubler.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Points doubler                                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Punkte verdoppeln                                *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!is_admin()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

if (isset($_POST['ok']))
{
	// Replace commata with decimal dot
	$_POST['doubler_charge'] = str_replace(",", ".", ($_POST['doubler_charge'] / 100));
	$_POST['doubler_ref']    = str_replace(",", ".", ($_POST['doubler_ref'] / 100));
	$_POST['doubler_min']    = str_replace(",", ".", $_POST['doubler_min']);
	$_POST['doubler_max']    = str_replace(",", ".", $_POST['doubler_max']);
	$_POST['doubler_left']   = str_replace(",", ".", $_POST['doubler_left']);

	// Save settings
	ADMIN_SAVE_SETTINGS($_POST, "_config", "config='0'");
}
 else
{
	// Prepare data for the template
	// - Charge rate
	define('__DOUBLER_CHARGE', TRANSLATE_COMMA(($CONFIG['doubler_charge'] * 100), false));
	// - Referral rate
	define('__DOUBLER_REFERRAL', TRANSLATE_COMMA(($CONFIG['doubler_ref'] * 100), false));
	// - Minimum points to double
	define('__DOUBLER_MINIMUM', TRANSLATE_COMMA($CONFIG['doubler_min'], false));
	// - Maximum points to double
	define('__DOUBLER_MAXIMUM', TRANSLATE_COMMA($CONFIG['doubler_max'], false));
	// - Points left on users account after doubling
	define('__DOUBLER_LEFT', TRANSLATE_COMMA($CONFIG['doubler_left'], false));
	// - Max payouts to check per click/reset
	define('__DOUBLER_MAX_SENT', $CONFIG['doubler_max_sent']);
	// - Group sending
	define('__DOUBLER_GROUP_SENT', $CONFIG['doubler_group_sent']);

	// Take points from jackpot (Y/N)
	switch ($CONFIG['doubler_jackpot'])
	{
	case 'Y':
		define('__DOUBLER_JACKPOT_Y', " checked");
		define('__DOUBLER_JACKPOT_N', "");
		break;

	case 'N':
		define('__DOUBLER_JACKPOT_Y', "");
		define('__DOUBLER_JACKPOT_N', " checked");
		break;
	}

	// Take points from own account (Y/N)
	switch ($CONFIG['doubler_own'])
	{
	case 'Y':
		define('__DOUBLER_OWN_Y', " checked");
		define('__DOUBLER_OWN_N', "");
		break;

	case 'N':
		define('__DOUBLER_OWN_Y', "");
		define('__DOUBLER_OWN_N', " checked");
		break;
	}

	// Mail send mode
	switch ($CONFIG['doubler_send_mode'])
	{
	case "DIRECT":
		define('__DOUBLER_SEND_DIRECT', " checked");
		define('__DOUBLER_SEND_RESET' , "");
		break;

	case "RESET":
		define('__DOUBLER_SEND_DIRECT', "");
		define('__DOUBLER_SEND_RESET' , " checked");
		break;
	}

	// Take points from own account (Y/N)
	switch ($CONFIG['doubler_sent_all'])
	{
	case 'Y':
		define('__DOUBLER_SENT_ALL_Y', " checked");
		define('__DOUBLER_SENT_ALL_N', "");
		break;

	case 'N':
		define('__DOUBLER_SENT_ALL_Y', "");
		define('__DOUBLER_SENT_ALL_N', " checked");
		break;
	}

	// Transfer options (!!!) to __MEMBER_SELECTION
	ADD_MEMBER_SELECTION_BOX(false, true, true, $CONFIG['doubler_uid']);

	// Number of rows to display (option lines!!!)
	define('__DOUBLER_DISPLAY_NEW', ADD_OPTION_LINES("/ARRAY/", array(5,10,20,30,40,50,100), array(5,10,20,30,40,50,100), $CONFIG['doubler_display_new']));
	define('__DOUBLER_DISPLAY_PAY', ADD_OPTION_LINES("/ARRAY/", array(5,10,20,30,40,50,100), array(5,10,20,30,40,50,100), $CONFIG['doubler_display_pay']));
	define('__DOUBLER_DISPLAY_OLD', ADD_OPTION_LINES("/ARRAY/", array(5,10,20,30,40,50,100), array(5,10,20,30,40,50,100), $CONFIG['doubler_display_old']));

	// Timeout selection box or input box?
	define('__DOUBLER_TIMEOUT', CREATE_TIME_SELECTIONS($CONFIG['doubler_timeout']  , "doubler_timeout"  , "WDh"));

	// Load template
	LOAD_TEMPLATE("admin_config_doubler");
}
//
?>
