<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/12/2004 *
 * ================                             Last change: 02/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_rewrite.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Rewrite-Engine configuration                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Rewrite-Engine Konfiguration                     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!is_admin()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

if (isset($_POST['ok']))
{
	// Generate string
	$MODs = array();
	foreach ($_POST['mod'] as $mod=>$sel)
	{
		// Now you can never deselect the admin module, bah!!! ;-)
		if (($sel == 'Y') || ($mod == "admin"))
		{
			// Add module to queue
			$MODs[] = $mod;
		}
	}

	// Implode array to string and remove posted mod array
	$_POST['rewrite_skip'] = implode(":", $MODs);
	unset($_POST['mod']);

	// Save settings
	ADMIN_SAVE_SETTINGS($_POST, "_config", "config='0'");
}
 else
{
	// Load existing modules and generate TR rows for the template
	$result = SQL_QUERY("SELECT module, title FROM "._MYSQL_PREFIX."_mod_reg ORDER BY module", __FILE__, __LINE__);
	$SW = 2; $OUT = "";
	while(list($mod, $title) = SQL_FETCHROW($result))
	{
		// Set title to three dashes when no title is supplied
		if (empty($title)) $title = "---";

		// Already registered module?
		if (ereg($mod, $CONFIG['rewrite_skipped_mods']))
		{
			// Found
			$y = " checked";
			$n = "";
		}
		 else
		{
			// Not found
			$y = "";
			$n = " checked";
		}

		// Remember data in array for the dynamic row template
		$content = array(
			'module'    => $mod,
			'title'     => $title,
			'y_default' => $y,
			'n_default' => $n,
			'sw'        => $SW,
		);

		// Load template and switch colors
		$OUT .= LOAD_TEMPLATE("admin_config_rewrite_rows", true, $content);
		$SW = 3 - $SW;
	}

	// Free memory
	SQL_FREERESULT($result);
	define('__MODULE_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_config_rewrite");
}
//
?>
