<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/06/2004 *
 * ================                             Last change: 10/06/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_transfer.php                         *
 * -------------------------------------------------------------------- *
 * Short description : Configuration of transfer system                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Konfiguration des Punktetransfersystems          *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!IS_ADMIN()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

if (isset($_POST['ok']))
{
	// Save settings...
	ADMIN_SAVE_SETTINGS($_POST, "_config", "config='0'");
}

// Prepare constants for template
define('__TRANS_MAX_VALUE'    , $CONFIG['transfer_max']);
define('__TRANS_BALANCE_VALUE', $CONFIG['transfer_balance']);
define('__TRANS_CODE_VALUE'   , $CONFIG['transfer_code']);

// Autppurge expired transfer entries?
switch ($CONFIG['ap_inactive'])
{
	case 'Y': define('__YES_AP', " selected=\"selected\""); define('__NO_AP', "");          break;
	case 'N': define('__YES_AP', "");          define('__NO_AP', " selected=\"selected\""); break;
}

// Time selection box
define('__TRANS_AGE_SELECTION'    , CREATE_TIME_SELECTIONS($CONFIG['transfer_age'], "transfer_age", "MWDh"));
define('__TRANS_TIMEOUT_SELECTION', CREATE_TIME_SELECTIONS($CONFIG['transfer_timeout'], "transfer_timeout", "MWDh"));

// Load template
LOAD_TEMPLATE("admin_config_transfer");

//
?>
